<!DOCTYPE html>
<html lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>11試PHP日記帳インストール</title>
</head>
<body>

<?php

	// 実行中インストールPHPのサーバー上パスを取得
	$file_path = $_SERVER["SCRIPT_FILENAME"];

	// 実行中インストールPHPのURLを取得
	$file_url = 'http://' . $_SERVER["HTTP_HOST"] . $_SERVER['PHP_SELF'];

	// 実行中インストールPHPのファイル名のみを分離
	$file_name = basename($file_path);

	// 実行中インストールPHPが配置されているサーバー上ディレクトリを保存
	$blog_dir = substr($file_path, 0, strlen($file_path) - (strlen($file_name) + 1));

	$blog_url = substr($file_url, 0, strlen($file_url) - strlen($file_name));

	// インストール段階取得
	$step = $_REQUEST['step'];

	if ($step == '') {
		$step = '0';
	}

	// インストール段階に応じた処理
	switch ($step) {

	// 初期設定情報の入力フォームを表示
	case 0:

		print '<p>サーバー上ディレクトリ<strong>' . $blog_dir . "</strong>に日記をインストールします。</p>\n";

		print '<form action="' . $file_name . '" method="post">' . "\n";
		print '<table border="1">' . "\n";
		print '<tr><th>日記名</th><td><input type="text" name="blog_name" size="32"></td></tr>' . "\n";
		print '<tr><th>日記URL</th><td><input type="text" name="blog_url" size="32" value="' . $blog_url . '"></td></tr>' . "\n";
		print '<tr><th>日記著者</th><td><input type="text" name="blog_author" size="32"></td></tr>' . "\n";
		print '<tr><th>記事ID前置文字列</th><td><input type="text" name="atom_id_prefix" size="32" value="' . $_SERVER["HTTP_HOST"] . '"></td></tr>' . "\n";
		print '<input type="hidden" name="step" value="1">' . "\n";
		print '<tr><td colspan="2" style="text-align: center;"><input type="submit" value="日記作成"></td></tr>' . "\n";
		print '</table>' . "\n";
		print '</form>' . "\n";

		break;

	// インストール実行
	case 1:

		print '<p>日記表示プログラムをインストールします。</p>' . "\n";

		$progfiles_list = array('article.php', 'index.php', 'list.php');

		$err = FALSE;

		// リストのファイルを配置
		foreach ($progfiles_list as $progfile) {

			$src_path = $blog_dir . '/_install/' . $progfile;
			$dst_path = $blog_dir . '/' . $progfile;

			if (copy($src_path, $dst_path)) {
				print $dst_path . "の配置を完了<br>\n";
			} else {

				print $dst_path . "の配置に失敗<br>\n";

				$err = TRUE;

			}

		}

		if ($err) {

			print "プログラムの配置に失敗しました。</p>\n";

			break;

		}

		$template_dir = $blog_dir . '/template';

		print '<p>テンプレートディレクトリ<strong>' . $template_dir . '</strong>を作成します。<br>' . "\n";

		// テンプレートディレクトリを作成
		if (!mkdir($template_dir)) {

			print '失敗。</p>' . "\n";

			break;

		}

		print '成功。</p>' . "\n";

		print '<p>テンプレートディレクトリにテンプレートファイルを配置します。<br>' . "\n";

		// テンプレートディレクトリに配置するファイルのリスト
		$templatefiles_list = array('article.template', 'index.template', 'list_item.template');

		$err = FALSE;

		// リストのファイルを配置
		foreach ($templatefiles_list as $templatefile) {

			$src_path = $blog_dir . '/_install/template/' . $templatefile;
			$dst_path = $template_dir . '/' . $templatefile;

			if (copy($src_path, $dst_path)) {
				print $dst_path . "の配置を完了<br>\n";
			} else {

				print $dst_path . "の配置に失敗<br>\n";

				$err = TRUE;

			}

		}

		if ($err) {

			print "テンプレートファイルの配置に失敗しました。</p>\n";

			break;

		}

		$blog_sysdir = $blog_dir . '/system';

		$db_path = $blog_sysdir . '/blog.db';

		print '<p>システムディレクトリ<strong>' . $blog_sysdir . '</strong>を作成します。<br>' . "\n";

		// システムディレクトリを作成
		if (!mkdir($blog_sysdir)) {

			print '失敗。</p>' . "\n";

			break;

		}

		print '成功。</p>' . "\n";

		// 設定ファイルのテンプレートを読み込む
		$ini_template = file_get_contents($blog_dir . '/_install/setting.ini.template');

		// テンプレートの設定タグを変換
		$ini_file = str_replace('<:db_path:>', $db_path, $ini_template);
		$ini_file = str_replace('<:blog_name:>', $_REQUEST['blog_name'], $ini_file);
		$ini_file = str_replace('<:blog_dir:>', $blog_dir, $ini_file);
		$ini_file = str_replace('<:blog_url:>', $_REQUEST['blog_url'], $ini_file);
		$ini_file = str_replace('<:blog_author:>', $_REQUEST['blog_author'], $ini_file);
		$ini_file = str_replace('<:atom_id_prefix:>', $_REQUEST['atom_id_prefix'], $ini_file);

		print '<p>システムディレクトリに設定ファイル<strong>setting.ini</strong>を作成します。<br>' . "\n";

		// 設定ファイルを書き出す
		if (!file_put_contents($blog_sysdir . '/setting.ini', $ini_file)) {

			print '失敗。</p>' . "\n";

			break;

		}

		print '成功。</p>' . "\n";

		print '<p>システムディレクトリにプログラムを配置します。<br>' . "\n";

		// システムディレクトリに配置するファイルのリスト
		$sysfiles_list = array('BlogDB.php', 'lib.php');

		$err = FALSE;

		// リストのファイルを配置
		foreach ($sysfiles_list as $sysfile) {

			$src_path = $blog_dir . '/_install/system/' . $sysfile;
			$dst_path = $blog_sysdir . '/' . $sysfile;

			if (copy($src_path, $dst_path)) {
				print $dst_path . "の配置を完了<br>\n";
			} else {

				print $dst_path . "の配置に失敗<br>\n";

				$err = TRUE;

			}

		}

		if ($err) {

			print "プログラムの配置に失敗しました。</p>\n";

			break;

		}

		print "システムディレクトリへのプログラム配置が完了しました。</p>\n";



		$admin_dir = $blog_dir . '/admin';

		print '<p>管理機能ディレクトリ<strong>' . $admin_dir . '</strong>を作成します。<br>' . "\n";

		// 管理機能ディレクトリを作成
		if (!mkdir($admin_dir)) {

			print '失敗。</p>' . "\n";

			break;

		}

		print '成功。</p>' . "\n";

		print '<p>管理機能ディレクトリに管理機能ファイルを配置します。<br>' . "\n";

		// 管理機能ディレクトリに配置するファイルのリスト
		$adminfiles_list = array('index.php', 'index.template', 'db_admin.php', 'article_edit.php', 'article_edit.template', 'article_delete.php', 'entry_write.php');

		$err = FALSE;

		// リストのファイルを配置
		foreach ($adminfiles_list as $adminfile) {

			$src_path = $blog_dir . '/_install/admin/' . $adminfile;
			$dst_path = $admin_dir . '/' . $adminfile;

			if (copy($src_path, $dst_path)) {
				print $dst_path . "の配置を完了<br>\n";
			} else {

				print $dst_path . "の配置に失敗<br>\n";

				$err = TRUE;

			}

		}

		if ($err) {

			print "管理機能ファイルの配置に失敗しました。</p>\n";

			break;

		}

		print '<p><a href="admin/">日記管理画面</a></p>' . "\n";

		break;

	}

?>

</body>
</html>
